
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Product_categoriesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const product_categories = await db.product_categories.create(
            {
                id: data.id || undefined,
        
        category_name: data.category_name
        ||
        null
            ,
            
        category_code: data.category_code
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await product_categories.setParent_category( data.parent_category || null, {
            transaction,
        });
        
        await product_categories.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return product_categories;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const product_categoriesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                category_name: item.category_name
            ||
            null
            ,
            
                category_code: item.category_code
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const product_categories = await db.product_categories.bulkCreate(product_categoriesData, { transaction });

        // For each item created, replace relation files
        

        return product_categories;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const product_categories = await db.product_categories.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.category_name !== undefined) updatePayload.category_name = data.category_name;
        
        
        if (data.category_code !== undefined) updatePayload.category_code = data.category_code;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        updatePayload.updatedById = currentUser.id;

        await product_categories.update(updatePayload, {transaction});

        
        
        if (data.parent_category !== undefined) {
            await product_categories.setParent_category(
              
              data.parent_category,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await product_categories.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return product_categories;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const product_categories = await db.product_categories.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of product_categories) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of product_categories) {
                await record.destroy({transaction});
            }
        });


        return product_categories;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const product_categories = await db.product_categories.findByPk(id, options);

        await product_categories.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await product_categories.destroy({
            transaction
        });

        return product_categories;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const product_categories = await db.product_categories.findOne(
            { where },
            { transaction },
        );

        if (!product_categories) {
            return product_categories;
        }

        const output = product_categories.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        output.products_category = await product_categories.getProducts_category({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.parent_category = await product_categories.getParent_category({
            transaction
        });
        
        
        output.organizations = await product_categories.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.product_categories,
        as: 'parent_category',
        
        where: filter.parent_category ? {
          [Op.or]: [
            { id: { [Op.in]: filter.parent_category.split('|').map(term => Utils.uuid(term)) } },
            {
              category_name: {
                [Op.or]: filter.parent_category.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.category_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'product_categories',
                        'category_name',
                        filter.category_name,
                    ),
                };
            }
            
            if (filter.category_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'product_categories',
                        'category_code',
                        filter.category_code,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'product_categories',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.product_categories.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'product_categories',
                        'category_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.product_categories.findAll({
            attributes: [ 'id', 'category_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['category_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.category_name,
        }));
    }

    
};

